-- $Id: TextMapTests.hs,v 1.2 2013/01/28 02:30:09 leavens Exp leavens $
module TextMapTests where
import Testing
import Text
import TextMap
import Data.Char

-- helpers for the tests, of type Sentence -> Sentence
capFirst (c:cs) = (toUpper c) : cs
capFirst cs = cs
period sent = sent ++ "."

-- do main to run our tests
main :: IO()
main = dotests "TextMapTests $Revision: 1.2 $" tests

tests :: [TestCase Text]
tests = 
 [(eqTest (textMap period (Paragraph [])) "==" (Paragraph []))
 ,(eqTest (textMap period (Section [])) "==" (Section []))
 ,(eqTest (textMap id (Paragraph ["a man","a plan"])) 
   "==" (Paragraph ["a man","a plan"]))
 ,(eqTest (textMap capFirst (Section [(Paragraph ["a man","a plan"])]))
   "==" (Section [(Paragraph ["A man","A plan"])]))
 ,(eqTest (textMap period (Section [(Paragraph ["a man","a plan"])
                                    ,(Paragraph ["a canal","Panama"])]))
   "==" (Section [(Paragraph ["a man.","a plan."])
                 ,(Paragraph ["a canal.","Panama."])]))
 ,(eqTest (textMap period 
           (Section [Paragraph ["a woman"]
                    ,(Section [Paragraph ["radiation"], (Paragraph ["rays","curie"])])]))
   "==" (Section [Paragraph ["a woman."]
                 ,(Section [Paragraph ["radiation."], (Paragraph ["rays.","curie."])])]))
 ,(eqTest (textMap (period . capFirst) 
           (Section [Paragraph ["a woman"]
                    ,(Section [Paragraph ["radiation"], (Paragraph ["rays","curie"])])]))
   "==" (Section [Paragraph ["A woman."]
                 ,(Section [Paragraph ["Radiation."] ,(Paragraph ["Rays.","Curie."])])]))
 ,(eqTest (textMap period
           (Section [(Section [(Section [(Section [(Paragraph ["OK"])])])])
                    ,(Paragraph ["I am","You are","Me too"]) ,(Section [])]))
   "==" (Section [(Section [(Section [(Section [(Paragraph ["OK."])])])])
                 ,(Paragraph ["I am.","You are.","Me too."]) ,(Section [])]))
 ]
